
#ifndef _NPXP_H_
#define _NPXP_H_

/*
** Stuff for the SetWindow method:
*/
#ifdef XP_UNIX
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#endif 

#define PLUGIN_NAME             "Express's First Plug-in"
#define PLUGIN_DESCRIPTION      "Demonstrates Express's basic plug-in understanding."
#define PLUGIN_MIME_DESCRIPTION	"application/x-xp-plugin:smp:Express's First Plug-in"

/*
* Define PLUGIN_TRACE to have the wrapper functions print
* messages to stderr whenever they are called.
*/

#ifdef PLUGIN_TRACE
#define PLUGINDEBUGSTR(msg)     fprintf(stderr, "%s\n", msg)
#else
#define PLUGINDEBUGSTR(msg)
#endif

/*******************************************************************************
 * Instance state information about the plugin.
 *
 * PLUGIN DEVELOPERS:
 *      Use this struct to hold per-instance information that you'll
 *      need in the various functions in this file.
 ******************************************************************************/

typedef struct _XPPluginInstance
{
   NPWindow*               fWindow;
   uint16                  fMode;

/* UNIX data members */
#ifdef XP_UNIX
   Display *display;
   Window window;
   Widget widget;
   uint32 x, y;
   uint32 width, height;
   int valid_window;
#endif
#ifdef MSDOS
   uint32 window;
   uint32 widget;
   uint32 x, y;
   uint32 width, height;
   int valid_window;
#endif
   
   void *info;			/* pointer to C++ classes */	

} XPPluginInstance;

#ifdef __cplusplus
extern "C" {
#endif

void XP_New(XPPluginInstance *);
void XP_Destroy(XPPluginInstance *);
void XP_SetWindow(XPPluginInstance *);

#ifdef __cplusplus
}  /* end extern "C" */
#endif

#endif /* _NPXP_H */

